*=== sQԁF͓IɎZo ;
%macro PROB1(_DELTA=2, _N1=20, _N2=20, _MU1=3, _MU2=0, _SD1=4, _SD2=5, _LOWER="Y") ;
  data PROB1 ;
    T=(&_DELTA.-(&_MU1.-&_MU2.))/
       sqrt( (1/&_N1.+1/&_N2.)*((&_N1.-1)*&_SD1.**2+(&_N2.-1)*&_SD2.**2)/(&_N1.+&_N2.-2) ) ;
    if (&_LOWER.="Y") then PROB=  cdf("t", T, &_N1.+&_N2.-2) ;
    else                   PROB=1-cdf("t", T, &_N1.+&_N2.-2) ;
  run ;
  proc print noobs ; run ;
%mend ;
%PROB1(_LOWER="N");



*=== NXI[o[F͓IɎZo ;
%macro PROB2(_DELTA=2, _N1=20, _N2=20, _Y11=6, _Y12=3, _Y21=2, _Y22=5, _SSE=250, _SSP=480, _LOWER="Y") ;
  data PROB2 ;
    M =(&_N1.+&_N2.)/(&_N1.*&_N2.) ;
    R =(&_Y11.+&_Y12.-&_Y21.-&_Y22.)/2 ;
    T =(&_Y11.-&_Y12.-&_Y21.+&_Y22.)/4 ;
    T1=(&_DELTA.-R)/sqrt((M*&_SSP.)/(2*(&_N1.+&_N2.-2))) ;
    T2=(&_DELTA.-T-R/2)/sqrt((M*&_SSE.)/(8*(&_N1.+&_N2.-2))) ;
    B1=(&_N1.+&_N2.-6)*(&_SSE.+&_SSP.)**2/(&_SSE.**2+&_SSP.**2)+4 ;
    B0=(B1-2)*(&_SSE.+&_SSP.)/(&_N1.+&_N2.-4) ;
    T3=(&_DELTA.-T-R/2)/sqrt((M*B0)/(8*B1)) ;

    if (&_LOWER.="Y") then do ;
      PROB1=cdf("t", T1, &_N1.+&_N2.-2) ;
      PROB2=cdf("t", T2, &_N1.+&_N2.-2) ;
      PROB3=cdf("t", T3, B1) ;
    end ;  
    else do ;
      PROB1=1-cdf("t", T1, &_N1.+&_N2.-2) ;
      PROB2=1-cdf("t", T2, &_N1.+&_N2.-2) ;
      PROB3=1-cdf("t", T3, B1) ;
    end ;
  run ;
  proc print noobs ; run ;
%mend ;
%PROB2(_LOWER="N");



*=== sQԁFMCMCɂĎZo ;
data MYDATA ;
  do GROUP=1 to 2 ;
    do ID=1 to 20 ;
      Y=3*(2-GROUP)+(3+GROUP)*normal(7777) ; output ;
    end ;
  end ;
run ;

proc glm data=MYDATA ;
  class   GROUP ;
  model   Y = GROUP / solution ss3 ;
  lsmeans GROUP / cl pdiff ;
run ;
quit ;

proc mcmc data=MYDATA outpost=OUT seed=777 nmc=10000 monitor=(_parms_ DIFF) statistics(alpha=0.05) ;
  parm mu1  0 mu2 0 ;
  parm sig2 1 ;
  prior mu:  ~ general(0) ;
  prior sig2 ~ general(-log(sig2), lower=0) ;
  diff = mu1 - mu2 ;
  if (GROUP=1) then mu = mu1 ;
  else              mu = mu2 ;
  model Y ~ normal(mu, var=sig2) ;
run ;

proc format ;
  value diff_f low -< 2   ="Diff <  2"
               2   <- high="Diff >= 2" ;
run ;

proc freq data=OUT ;
  tables diff / nocum ;
  format diff diff_f. ;
run ;

proc mcmc data=MYDATA outpost=OUT seed=777 nbi=5000 thin=5 nmc=50000 monitor=(_parms_ DIFF) statistics(alpha=0.05) ;
  parm mu1  0 mu2 0 ;
  parm sig2 1 ;
  prior mu:  ~ general(0) ;
  prior sig2 ~ general(-log(sig2), lower=0) ;
  diff = mu1 - mu2 ;
  if (GROUP=1) then mu = mu1 ;
  else              mu = mu2 ;
  model Y ~ normal(mu, var=sig2) ;
run ;

proc mcmc data=MYDATA outpost=OUT seed=777 nbi=5000 thin=5 nmc=50000 statistics(alpha=0.05) ;
  parm   int  0 ;
  parm   sig2 1 ;
  prior  int  ~ general(0) ;
  prior  sig2 ~ general(-log(sig2), lower=0) ;
  random mu   ~ general(0) subject=GROUP monitor=(mu) init=0 zero=last ;

  model Y ~ normal(int+mu, var=sig2) ;
run ;

proc freq data=OUT ;
  tables mu_1 / nocum ;
  format mu_1 diff_f. ;
run ;



*=== NXI[o[FMCMCɂĎZo ;
data MYDATA ;
  GROUP=1 ;
  do ID=1 to 20 ;
    PERIOD=1; TREAT=1; Y=6+3*normal(7777) ; output ;
    PERIOD=2; TREAT=2; Y=3+3*normal(7777) ; output ;
  end ;

  GROUP=2 ;
  do ID=21 to 40 ;
    PERIOD=1; TREAT=2; Y=2+3*normal(7777) ; output ;
    PERIOD=2; TREAT=1; Y=5+3*normal(7777) ; output ;
  end ;
run ;

proc glm data=MYDATA ;
  class   ID GROUP PERIOD TREAT ;
  model   Y = GROUP ID(GROUP) PERIOD TREAT / solution ss3 ;
  test    h=GROUP e=ID(GROUP) ;
  lsmeans TREAT / cl pdiff ;
run ;
quit ;

/*
proc mixed data=MYDATA ;
  class   ID GROUP PERIOD TREAT ;
  model   Y = GROUP PERIOD TREAT / solution ;
  random  ID ;
  lsmeans TREAT / pdiff cl ;
run ;

proc genmod data=MYDATA ;
  class   ID GROUP PERIOD TREAT ;
  model   Y = GROUP ID(GROUP) PERIOD TREAT / dist=normal ;
  lsmeans TREAT / pdiff cl ;
run;
*/

proc mcmc data=MYDATA outpost=OUT seed=777 nbi=5000 thin=5 nmc=50000 statistics(alpha=0.05) ;
  parms  residual 1 sig2 1 ;
  prior  residual ~ igamma(0.001, scale=0.001)  ;
  prior  sig2     ~ igamma(0.001, scale=0.001)  ;
  random seq      ~ normal(0, var=1000) subject=GROUP  monitor=(seq) zero=last ;
  random tau      ~ normal(0, var=1000) subject=TREAT  monitor=(tau) zero=last ;
  random pi       ~ normal(0, var=1000) subject=PERIOD monitor=(pi)  ;
  random s        ~ normal(0, var=sig2) subject=ID ;

  model y ~ normal(seq + tau + pi + s, var=residual) ;
run ;

proc format ;
  value diff_f low -< 2   ="Diff <  2"
               2   <- high="Diff >= 2" ;
run ;

proc freq data=OUT ;
  tables tau_1 / nocum ;
  format tau_1 diff_f. ;
run ;



*=== NUTS ɂĉ ;
data MYDATA ;
  do GROUP=1 to 2 ;
    do ID=1 to 20 ;
      Y=3*(2-GROUP)+(3+GROUP)*normal(7777) ; output ;
    end ;
  end ;
run ;

proc mcmc data=MYDATA outpost=OUT seed=777 nbi=5000 thin=5 nmc=50000 monitor=(_parms_ DIFF) statistics(alpha=0.05) diag=all ;
  parm mu1  0 mu2 0 ;
  parm sig2 1 ;
  prior mu:  ~ general(0) ;
  prior sig2 ~ general(-log(sig2), lower=0) ;
  diff = mu1 - mu2 ;
  if (GROUP=1) then mu = mu1 ;
  else              mu = mu2 ;
  model Y ~ normal(mu, var=sig2) ;
run ;

proc mcmc data=MYDATA outpost=OUT seed=777 nbi=5000 thin=5 nmc=50000 monitor=(_parms_ DIFF) statistics(alpha=0.05) diag=all alg=nuts ;
  parm mu1  0 mu2 0 ;
  parm sig2 1 ;
  prior mu:  ~ general(0) ;
  prior sig2 ~ general(-log(sig2), lower=0) ;
  diff = mu1 - mu2 ;
  if (GROUP=1) then mu = mu1 ;
  else              mu = mu2 ;
  model Y ~ normal(mu, var=sig2) ;
run ;

proc mcmc data=MYDATA outpost=OUT seed=777 nbi=5000 thin=5 nmc=5000 monitor=(_parms_ DIFF) statistics(alpha=0.05) diag=all alg=nuts ;
  parm mu1  0 mu2 0 ;
  parm sig2 1 ;
  prior mu:  ~ general(0) ;
  prior sig2 ~ general(-log(sig2), lower=0) ;
  diff = mu1 - mu2 ;
  if (GROUP=1) then mu = mu1 ;
  else              mu = mu2 ;
  model Y ~ normal(mu, var=sig2) ;
run ;

proc mcmc data=MYDATA outpost=OUT seed=777 nbi=5000 thin=5 nmc=500 monitor=(_parms_ DIFF) statistics(alpha=0.05) diag=all alg=nuts ;
  parm mu1  0 mu2 0 ;
  parm sig2 1 ;
  prior mu:  ~ general(0) ;
  prior sig2 ~ general(-log(sig2), lower=0) ;
  diff = mu1 - mu2 ;
  if (GROUP=1) then mu = mu1 ;
  else              mu = mu2 ;
  model Y ~ normal(mu, var=sig2) ;
run ;

*** ;

data MYDATA ;
  GROUP=1 ;
  do ID=1 to 20 ;
    PERIOD=1; TREAT=1; Y=6+3*normal(7777) ; output ;
    PERIOD=2; TREAT=2; Y=3+3*normal(7777) ; output ;
  end ;

  GROUP=2 ;
  do ID=21 to 40 ;
    PERIOD=1; TREAT=2; Y=2+3*normal(7777) ; output ;
    PERIOD=2; TREAT=1; Y=5+3*normal(7777) ; output ;
  end ;
run ;

proc mcmc data=MYDATA outpost=OUT seed=777 nbi=10000 thin=10 nmc=100000 statistics(alpha=0.05) diag=all ;
   parms  residual 1 sig2 1 ;
   prior  residual ~ igamma(0.001, scale=0.001)  ;
   prior  sig2     ~ igamma(0.001, scale=0.001)  ;
   random seq      ~ normal(0, var=1000) subject=GROUP  monitor=(seq) zero=last ;
   random tau      ~ normal(0, var=1000) subject=TREAT  monitor=(tau) zero=last ;
   random pi       ~ normal(0, var=1000) subject=PERIOD monitor=(pi)  ;
   random s        ~ normal(0, var=sig2) subject=ID ;

   model y ~ normal(seq + tau + pi + s, var=residual) ;
run ;

proc mcmc data=MYDATA outpost=OUT seed=777 nbi=10000 thin=10 nmc=100000 statistics(alpha=0.05) diag=all alg=nuts ;
   parms  residual 1 sig2 1 ;
   prior  residual ~ igamma(0.001, scale=0.001)  ;
   prior  sig2     ~ igamma(0.001, scale=0.001)  ;
   random seq      ~ normal(0, var=1000) subject=GROUP  monitor=(seq) zero=last ;
   random tau      ~ normal(0, var=1000) subject=TREAT  monitor=(tau) zero=last ;
   random pi       ~ normal(0, var=1000) subject=PERIOD monitor=(pi)  ;
   random s        ~ normal(0, var=sig2) subject=ID ;

   model y ~ normal(seq + tau + pi + s, var=residual) ;
run ;

proc mcmc data=MYDATA outpost=OUT seed=777 nbi=10000 thin=10 nmc=10000 statistics(alpha=0.05) diag=all alg=nuts ;
   parms  residual 1 sig2 1 ;
   prior  residual ~ igamma(0.001, scale=0.001)  ;
   prior  sig2     ~ igamma(0.001, scale=0.001)  ;
   random seq      ~ normal(0, var=1000) subject=GROUP  monitor=(seq) zero=last ;
   random tau      ~ normal(0, var=1000) subject=TREAT  monitor=(tau) zero=last ;
   random pi       ~ normal(0, var=1000) subject=PERIOD monitor=(pi)  ;
   random s        ~ normal(0, var=sig2) subject=ID ;

   model y ~ normal(seq + tau + pi + s, var=residual) ;
run ;
